/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the ReportRawDataEntry type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportRawDataEntry{}

// ReportRawDataEntry struct for ReportRawDataEntry
type ReportRawDataEntry struct {
	Date string `json:"date"`
	Year string `json:"year"`
	Month string `json:"month"`
	Day string `json:"day"`
	Hour string `json:"hour"`
	Weekday string `json:"weekday"`
	OrganizationId string `json:"organization_id"`
	ChannelId string `json:"channel_id"`
	ChannelName string `json:"channel_name"`
	LocationId string `json:"location_id"`
	LocationName string `json:"location_name"`
	Consents int32 `json:"consents"`
	ChatStarted int32 `json:"chat_started"`
	MainActions int32 `json:"main_actions"`
	Investments int32 `json:"investments"`
	Timestamp time.Time `json:"timestamp"`
}

// NewReportRawDataEntry instantiates a new ReportRawDataEntry object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportRawDataEntry(date string, year string, month string, day string, hour string, weekday string, organizationId string, channelId string, channelName string, locationId string, locationName string, consents int32, chatStarted int32, mainActions int32, investments int32, timestamp time.Time) *ReportRawDataEntry {
	this := ReportRawDataEntry{}
	this.Date = date
	this.Year = year
	this.Month = month
	this.Day = day
	this.Hour = hour
	this.Weekday = weekday
	this.OrganizationId = organizationId
	this.ChannelId = channelId
	this.ChannelName = channelName
	this.LocationId = locationId
	this.LocationName = locationName
	this.Consents = consents
	this.ChatStarted = chatStarted
	this.MainActions = mainActions
	this.Investments = investments
	this.Timestamp = timestamp
	return &this
}

// NewReportRawDataEntryWithDefaults instantiates a new ReportRawDataEntry object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportRawDataEntryWithDefaults() *ReportRawDataEntry {
	this := ReportRawDataEntry{}
	return &this
}

// GetDate returns the Date field value
func (o *ReportRawDataEntry) GetDate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Date
}

// GetDateOk returns a tuple with the Date field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetDateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Date, true
}

// SetDate sets field value
func (o *ReportRawDataEntry) SetDate(v string) {
	o.Date = v
}

// GetYear returns the Year field value
func (o *ReportRawDataEntry) GetYear() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Year
}

// GetYearOk returns a tuple with the Year field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetYearOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Year, true
}

// SetYear sets field value
func (o *ReportRawDataEntry) SetYear(v string) {
	o.Year = v
}

// GetMonth returns the Month field value
func (o *ReportRawDataEntry) GetMonth() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Month
}

// GetMonthOk returns a tuple with the Month field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetMonthOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Month, true
}

// SetMonth sets field value
func (o *ReportRawDataEntry) SetMonth(v string) {
	o.Month = v
}

// GetDay returns the Day field value
func (o *ReportRawDataEntry) GetDay() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Day
}

// GetDayOk returns a tuple with the Day field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetDayOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Day, true
}

// SetDay sets field value
func (o *ReportRawDataEntry) SetDay(v string) {
	o.Day = v
}

// GetHour returns the Hour field value
func (o *ReportRawDataEntry) GetHour() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Hour
}

// GetHourOk returns a tuple with the Hour field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetHourOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Hour, true
}

// SetHour sets field value
func (o *ReportRawDataEntry) SetHour(v string) {
	o.Hour = v
}

// GetWeekday returns the Weekday field value
func (o *ReportRawDataEntry) GetWeekday() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Weekday
}

// GetWeekdayOk returns a tuple with the Weekday field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetWeekdayOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Weekday, true
}

// SetWeekday sets field value
func (o *ReportRawDataEntry) SetWeekday(v string) {
	o.Weekday = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *ReportRawDataEntry) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *ReportRawDataEntry) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetChannelId returns the ChannelId field value
func (o *ReportRawDataEntry) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *ReportRawDataEntry) SetChannelId(v string) {
	o.ChannelId = v
}

// GetChannelName returns the ChannelName field value
func (o *ReportRawDataEntry) GetChannelName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelName
}

// GetChannelNameOk returns a tuple with the ChannelName field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetChannelNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelName, true
}

// SetChannelName sets field value
func (o *ReportRawDataEntry) SetChannelName(v string) {
	o.ChannelName = v
}

// GetLocationId returns the LocationId field value
func (o *ReportRawDataEntry) GetLocationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.LocationId
}

// GetLocationIdOk returns a tuple with the LocationId field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetLocationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LocationId, true
}

// SetLocationId sets field value
func (o *ReportRawDataEntry) SetLocationId(v string) {
	o.LocationId = v
}

// GetLocationName returns the LocationName field value
func (o *ReportRawDataEntry) GetLocationName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.LocationName
}

// GetLocationNameOk returns a tuple with the LocationName field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetLocationNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LocationName, true
}

// SetLocationName sets field value
func (o *ReportRawDataEntry) SetLocationName(v string) {
	o.LocationName = v
}

// GetConsents returns the Consents field value
func (o *ReportRawDataEntry) GetConsents() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Consents
}

// GetConsentsOk returns a tuple with the Consents field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetConsentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Consents, true
}

// SetConsents sets field value
func (o *ReportRawDataEntry) SetConsents(v int32) {
	o.Consents = v
}

// GetChatStarted returns the ChatStarted field value
func (o *ReportRawDataEntry) GetChatStarted() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ChatStarted
}

// GetChatStartedOk returns a tuple with the ChatStarted field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetChatStartedOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChatStarted, true
}

// SetChatStarted sets field value
func (o *ReportRawDataEntry) SetChatStarted(v int32) {
	o.ChatStarted = v
}

// GetMainActions returns the MainActions field value
func (o *ReportRawDataEntry) GetMainActions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.MainActions
}

// GetMainActionsOk returns a tuple with the MainActions field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetMainActionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MainActions, true
}

// SetMainActions sets field value
func (o *ReportRawDataEntry) SetMainActions(v int32) {
	o.MainActions = v
}

// GetInvestments returns the Investments field value
func (o *ReportRawDataEntry) GetInvestments() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Investments
}

// GetInvestmentsOk returns a tuple with the Investments field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetInvestmentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Investments, true
}

// SetInvestments sets field value
func (o *ReportRawDataEntry) SetInvestments(v int32) {
	o.Investments = v
}

// GetTimestamp returns the Timestamp field value
func (o *ReportRawDataEntry) GetTimestamp() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value
// and a boolean to check if the value has been set.
func (o *ReportRawDataEntry) GetTimestampOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Timestamp, true
}

// SetTimestamp sets field value
func (o *ReportRawDataEntry) SetTimestamp(v time.Time) {
	o.Timestamp = v
}

func (o ReportRawDataEntry) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportRawDataEntry) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["date"] = o.Date
	toSerialize["year"] = o.Year
	toSerialize["month"] = o.Month
	toSerialize["day"] = o.Day
	toSerialize["hour"] = o.Hour
	toSerialize["weekday"] = o.Weekday
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["channel_name"] = o.ChannelName
	toSerialize["location_id"] = o.LocationId
	toSerialize["location_name"] = o.LocationName
	toSerialize["consents"] = o.Consents
	toSerialize["chat_started"] = o.ChatStarted
	toSerialize["main_actions"] = o.MainActions
	toSerialize["investments"] = o.Investments
	toSerialize["timestamp"] = o.Timestamp
	return toSerialize, nil
}

type NullableReportRawDataEntry struct {
	value *ReportRawDataEntry
	isSet bool
}

func (v NullableReportRawDataEntry) Get() *ReportRawDataEntry {
	return v.value
}

func (v *NullableReportRawDataEntry) Set(val *ReportRawDataEntry) {
	v.value = val
	v.isSet = true
}

func (v NullableReportRawDataEntry) IsSet() bool {
	return v.isSet
}

func (v *NullableReportRawDataEntry) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportRawDataEntry(val *ReportRawDataEntry) *NullableReportRawDataEntry {
	return &NullableReportRawDataEntry{value: val, isSet: true}
}

func (v NullableReportRawDataEntry) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportRawDataEntry) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


